-- This file is part of Qtah.
--
-- Copyright 2015-2019 The Qtah Authors.
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Lesser General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Lesser General Public License for more details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Graphics.UI.Qtah.Generator.Interface.Core.QParallelAnimationGroup (
  aModule,
  c_QParallelAnimationGroup,
  ) where

import Foreign.Hoppy.Generator.Spec (
  addReqIncludes,
  classSetEntityPrefix,
  ident,
  includeStd,
  makeClass,
  )
import Graphics.UI.Qtah.Generator.Interface.Core.QAnimationGroup (c_QAnimationGroup)
--import Graphics.UI.Qtah.Generator.Interface.Core.QObject (c_QObject)
--import Foreign.Hoppy.Generator.Types (voidT, enumT, flagsT, constT, objT, ptrT, refT)
import Foreign.Hoppy.Generator.Version (collect)
import Graphics.UI.Qtah.Generator.Module (AModule (AQtModule), makeQtModuleWithMinVersion)
import Graphics.UI.Qtah.Generator.Types

{-# ANN module "HLint: ignore Use camelCase" #-}

aModule =
  AQtModule $
  makeQtModuleWithMinVersion ["Core", "QParallelAnimationGroup"] [4, 6] $
  [qtExport c_QParallelAnimationGroup]

c_QParallelAnimationGroup =
  addReqIncludes [ includeStd "QParallelAnimationGroup" ] $
  classSetEntityPrefix "" $
  makeClass (ident "QParallelAnimationGroup") Nothing [c_QAnimationGroup] $
  collect
  [
  -- TODO Methods
  ]
